Merge branch 'hb/gitweb-project-list'
[git/git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
15 or: $dashless clear"
16
17 SUBDIRECTORY_OK=Yes
18 OPTIONS_SPEC=
19 START_DIR=$(pwd)
20 . git-sh-setup
21 require_work_tree
22 prefix=$(git rev-parse --show-prefix) || exit 1
23 cd_to_toplevel
24
25 TMP="$GIT_DIR/.git-stash.$$"
26 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28
29 ref_stash=refs/stash
30
31 if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34 else
35 help_color=
36 reset_color=
37 fi
38
39 no_changes () {
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" || test -z "$(untracked_files)")
43 }
44
45 untracked_files () {
46 excl_opt=--exclude-standard
47 test "$untracked" = "all" && excl_opt=
48 git ls-files -o -z $excl_opt -- "$@"
49 }
50
51 clear_stash () {
52 if test $# != 0
53 then
54 die "$(gettext "git stash clear with parameters is unimplemented")"
55 fi
56 if current=$(git rev-parse --verify --quiet $ref_stash)
57 then
58 git update-ref -d $ref_stash $current
59 fi
60 }
61
62 create_stash () {
63 stash_msg=
64 untracked=
65 while test $# != 0
66 do
67 case "$1" in
68 -m|--message)
69 shift
70 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
71 ;;
72 -u|--include-untracked)
73 shift
74 untracked=${1?"BUG: create_stash () -u requires an argument"}
75 ;;
76 --)
77 shift
78 break
79 ;;
80 esac
81 shift
82 done
83
84 git update-index -q --refresh
85 if no_changes "$@"
86 then
87 exit 0
88 fi
89
90 # state of the base commit
91 if b_commit=$(git rev-parse --verify HEAD)
92 then
93 head=$(git rev-list --oneline -n 1 HEAD --)
94 else
95 die "$(gettext "You do not have the initial commit yet")"
96 fi
97
98 if branch=$(git symbolic-ref -q HEAD)
99 then
100 branch=${branch#refs/heads/}
101 else
102 branch='(no branch)'
103 fi
104 msg=$(printf '%s: %s' "$branch" "$head")
105
106 # state of the index
107 i_tree=$(git write-tree) &&
108 i_commit=$(printf 'index on %s\n' "$msg" |
109 git commit-tree $i_tree -p $b_commit) ||
110 die "$(gettext "Cannot save the current index state")"
111
112 if test -n "$untracked"
113 then
114 # Untracked files are stored by themselves in a parentless commit, for
115 # ease of unpacking later.
116 u_commit=$(
117 untracked_files "$@" | (
118 GIT_INDEX_FILE="$TMPindex" &&
119 export GIT_INDEX_FILE &&
120 rm -f "$TMPindex" &&
121 git update-index -z --add --remove --stdin &&
122 u_tree=$(git write-tree) &&
123 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
124 rm -f "$TMPindex"
125 ) ) || die "$(gettext "Cannot save the untracked files")"
126
127 untracked_commit_option="-p $u_commit";
128 else
129 untracked_commit_option=
130 fi
131
132 if test -z "$patch_mode"
133 then
134
135 # state of the working tree
136 w_tree=$( (
137 git read-tree --index-output="$TMPindex" -m $i_tree &&
138 GIT_INDEX_FILE="$TMPindex" &&
139 export GIT_INDEX_FILE &&
140 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
141 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
142 git write-tree &&
143 rm -f "$TMPindex"
144 ) ) ||
145 die "$(gettext "Cannot save the current worktree state")"
146
147 else
148
149 rm -f "$TMP-index" &&
150 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
151
152 # find out what the user wants
153 GIT_INDEX_FILE="$TMP-index" \
154 git add--interactive --patch=stash -- "$@" &&
155
156 # state of the working tree
157 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
158 die "$(gettext "Cannot save the current worktree state")"
159
160 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
161 test -s "$TMP-patch" ||
162 die "$(gettext "No changes selected")"
163
164 rm -f "$TMP-index" ||
165 die "$(gettext "Cannot remove temporary index (can't happen)")"
166
167 fi
168
169 # create the stash
170 if test -z "$stash_msg"
171 then
172 stash_msg=$(printf 'WIP on %s' "$msg")
173 else
174 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
175 fi
176 w_commit=$(printf '%s\n' "$stash_msg" |
177 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
178 die "$(gettext "Cannot record working tree state")"
179 }
180
181 store_stash () {
182 while test $# != 0
183 do
184 case "$1" in
185 -m|--message)
186 shift
187 stash_msg="$1"
188 ;;
189 -q|--quiet)
190 quiet=t
191 ;;
192 *)
193 break
194 ;;
195 esac
196 shift
197 done
198 test $# = 1 ||
199 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
200
201 w_commit="$1"
202 if test -z "$stash_msg"
203 then
204 stash_msg="Created via \"git stash store\"."
205 fi
206
207 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
208 ret=$?
209 test $ret != 0 && test -z "$quiet" &&
210 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
211 return $ret
212 }
213
214 push_stash () {
215 keep_index=
216 patch_mode=
217 untracked=
218 stash_msg=
219 while test $# != 0
220 do
221 case "$1" in
222 -k|--keep-index)
223 keep_index=t
224 ;;
225 --no-keep-index)
226 keep_index=n
227 ;;
228 -p|--patch)
229 patch_mode=t
230 # only default to keep if we don't already have an override
231 test -z "$keep_index" && keep_index=t
232 ;;
233 -q|--quiet)
234 GIT_QUIET=t
235 ;;
236 -u|--include-untracked)
237 untracked=untracked
238 ;;
239 -a|--all)
240 untracked=all
241 ;;
242 -m|--message)
243 shift
244 test -z ${1+x} && usage
245 stash_msg=$1
246 ;;
247 --help)
248 show_help
249 ;;
250 --)
251 shift
252 break
253 ;;
254 -*)
255 option="$1"
256 # TRANSLATORS: $option is an invalid option, like
257 # `--blah-blah'. The 7 spaces at the beginning of the
258 # second line correspond to "error: ". So you should line
259 # up the second line with however many characters the
260 # translation of "error: " takes in your language. E.g. in
261 # English this is:
262 #
263 # $ git stash save --blah-blah 2>&1 | head -n 2
264 # error: unknown option for 'stash save': --blah-blah
265 # To provide a message, use git stash save -- '--blah-blah'
266 eval_gettextln "error: unknown option for 'stash save': \$option
267 To provide a message, use git stash save -- '\$option'"
268 usage
269 ;;
270 *)
271 break
272 ;;
273 esac
274 shift
275 done
276
277 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
278
279 if test -n "$patch_mode" && test -n "$untracked"
280 then
281 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
282 fi
283
284 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
285
286 git update-index -q --refresh
287 if no_changes "$@"
288 then
289 say "$(gettext "No local changes to save")"
290 exit 0
291 fi
292
293 git reflog exists $ref_stash ||
294 clear_stash || die "$(gettext "Cannot initialize stash")"
295
296 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
297 store_stash -m "$stash_msg" -q $w_commit ||
298 die "$(gettext "Cannot save the current status")"
299 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
300
301 if test -z "$patch_mode"
302 then
303 if test $# != 0
304 then
305 git reset -q -- "$@"
306 git ls-files -z --modified -- "$@" |
307 git checkout-index -z --force --stdin
308 git clean --force -q -d -- "$@"
309 else
310 git reset --hard -q
311 fi
312 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
313 if test -n "$untracked"
314 then
315 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
316 fi
317
318 if test "$keep_index" = "t" && test -n "$i_tree"
319 then
320 git read-tree --reset $i_tree
321 git ls-files -z --modified -- "$@" |
322 git checkout-index -z --force --stdin
323 fi
324 else
325 git apply -R < "$TMP-patch" ||
326 die "$(gettext "Cannot remove worktree changes")"
327
328 if test "$keep_index" != "t"
329 then
330 git reset -q -- "$@"
331 fi
332 fi
333 }
334
335 save_stash () {
336 push_options=
337 while test $# != 0
338 do
339 case "$1" in
340 --)
341 shift
342 break
343 ;;
344 -*)
345 # pass all options through to push_stash
346 push_options="$push_options $1"
347 ;;
348 *)
349 break
350 ;;
351 esac
352 shift
353 done
354
355 stash_msg="$*"
356
357 if test -z "$stash_msg"
358 then
359 push_stash $push_options
360 else
361 push_stash $push_options -m "$stash_msg"
362 fi
363 }
364
365 have_stash () {
366 git rev-parse --verify --quiet $ref_stash >/dev/null
367 }
368
369 list_stash () {
370 have_stash || return 0
371 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
372 }
373
374 show_stash () {
375 ALLOW_UNKNOWN_FLAGS=t
376 assert_stash_like "$@"
377
378 if test -z "$FLAGS"
379 then
380 if test "$(git config --bool stash.showStat || echo true)" = "true"
381 then
382 FLAGS=--stat
383 fi
384
385 if test "$(git config --bool stash.showPatch || echo false)" = "true"
386 then
387 FLAGS=${FLAGS}${FLAGS:+ }-p
388 fi
389
390 if test -z "$FLAGS"
391 then
392 return 0
393 fi
394 fi
395
396 git diff ${FLAGS} $b_commit $w_commit
397 }
398
399 show_help () {
400 exec git help stash
401 exit 1
402 }
403
404 #
405 # Parses the remaining options looking for flags and
406 # at most one revision defaulting to ${ref_stash}@{0}
407 # if none found.
408 #
409 # Derives related tree and commit objects from the
410 # revision, if one is found.
411 #
412 # stash records the work tree, and is a merge between the
413 # base commit (first parent) and the index tree (second parent).
414 #
415 # REV is set to the symbolic version of the specified stash-like commit
416 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
417 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
418 # s is set to the SHA1 of the stash commit
419 # w_commit is set to the commit containing the working tree
420 # b_commit is set to the base commit
421 # i_commit is set to the commit containing the index tree
422 # u_commit is set to the commit containing the untracked files tree
423 # w_tree is set to the working tree
424 # b_tree is set to the base tree
425 # i_tree is set to the index tree
426 # u_tree is set to the untracked files tree
427 #
428 # GIT_QUIET is set to t if -q is specified
429 # INDEX_OPTION is set to --index if --index is specified.
430 # FLAGS is set to the remaining flags (if allowed)
431 #
432 # dies if:
433 # * too many revisions specified
434 # * no revision is specified and there is no stash stack
435 # * a revision is specified which cannot be resolve to a SHA1
436 # * a non-existent stash reference is specified
437 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
438 #
439
440 parse_flags_and_rev()
441 {
442 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
443 PARSE_CACHE="$*"
444
445 IS_STASH_LIKE=
446 IS_STASH_REF=
447 INDEX_OPTION=
448 s=
449 w_commit=
450 b_commit=
451 i_commit=
452 u_commit=
453 w_tree=
454 b_tree=
455 i_tree=
456 u_tree=
457
458 FLAGS=
459 REV=
460 for opt
461 do
462 case "$opt" in
463 -q|--quiet)
464 GIT_QUIET=-t
465 ;;
466 --index)
467 INDEX_OPTION=--index
468 ;;
469 --help)
470 show_help
471 ;;
472 -*)
473 test "$ALLOW_UNKNOWN_FLAGS" = t ||
474 die "$(eval_gettext "unknown option: \$opt")"
475 FLAGS="${FLAGS}${FLAGS:+ }$opt"
476 ;;
477 *)
478 REV="${REV}${REV:+ }'$opt'"
479 ;;
480 esac
481 done
482
483 eval set -- $REV
484
485 case $# in
486 0)
487 have_stash || die "$(gettext "No stash entries found.")"
488 set -- ${ref_stash}@{0}
489 ;;
490 1)
491 :
492 ;;
493 *)
494 die "$(eval_gettext "Too many revisions specified: \$REV")"
495 ;;
496 esac
497
498 case "$1" in
499 *[!0-9]*)
500 :
501 ;;
502 *)
503 set -- "${ref_stash}@{$1}"
504 ;;
505 esac
506
507 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
508 reference="$1"
509 die "$(eval_gettext "\$reference is not a valid reference")"
510 }
511
512 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
513 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
514 s=$1 &&
515 w_commit=$1 &&
516 b_commit=$2 &&
517 w_tree=$3 &&
518 b_tree=$4 &&
519 i_tree=$5 &&
520 IS_STASH_LIKE=t &&
521 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
522 IS_STASH_REF=t
523
524 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
525 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
526 }
527
528 is_stash_like()
529 {
530 parse_flags_and_rev "$@"
531 test -n "$IS_STASH_LIKE"
532 }
533
534 assert_stash_like() {
535 is_stash_like "$@" || {
536 args="$*"
537 die "$(eval_gettext "'\$args' is not a stash-like commit")"
538 }
539 }
540
541 is_stash_ref() {
542 is_stash_like "$@" && test -n "$IS_STASH_REF"
543 }
544
545 assert_stash_ref() {
546 is_stash_ref "$@" || {
547 args="$*"
548 die "$(eval_gettext "'\$args' is not a stash reference")"
549 }
550 }
551
552 apply_stash () {
553
554 assert_stash_like "$@"
555
556 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
557
558 # current index state
559 c_tree=$(git write-tree) ||
560 die "$(gettext "Cannot apply a stash in the middle of a merge")"
561
562 unstashed_index_tree=
563 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
564 test "$c_tree" != "$i_tree"
565 then
566 git diff-tree --binary $s^2^..$s^2 | git apply --cached
567 test $? -ne 0 &&
568 die "$(gettext "Conflicts in index. Try without --index.")"
569 unstashed_index_tree=$(git write-tree) ||
570 die "$(gettext "Could not save index tree")"
571 git reset
572 fi
573
574 if test -n "$u_tree"
575 then
576 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
577 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
578 rm -f "$TMPindex" ||
579 die "$(gettext "Could not restore untracked files from stash entry")"
580 fi
581
582 eval "
583 GITHEAD_$w_tree='Stashed changes' &&
584 GITHEAD_$c_tree='Updated upstream' &&
585 GITHEAD_$b_tree='Version stash was based on' &&
586 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
587 "
588
589 if test -n "$GIT_QUIET"
590 then
591 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
592 fi
593 if git merge-recursive $b_tree -- $c_tree $w_tree
594 then
595 # No conflict
596 if test -n "$unstashed_index_tree"
597 then
598 git read-tree "$unstashed_index_tree"
599 else
600 a="$TMP-added" &&
601 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
602 git read-tree --reset $c_tree &&
603 git update-index --add --stdin <"$a" ||
604 die "$(gettext "Cannot unstage modified files")"
605 rm -f "$a"
606 fi
607 squelch=
608 if test -n "$GIT_QUIET"
609 then
610 squelch='>/dev/null 2>&1'
611 fi
612 (cd "$START_DIR" && eval "git status $squelch") || :
613 else
614 # Merge conflict; keep the exit status from merge-recursive
615 status=$?
616 git rerere
617 if test -n "$INDEX_OPTION"
618 then
619 gettextln "Index was not unstashed." >&2
620 fi
621 exit $status
622 fi
623 }
624
625 pop_stash() {
626 assert_stash_ref "$@"
627
628 if apply_stash "$@"
629 then
630 drop_stash "$@"
631 else
632 status=$?
633 say "$(gettext "The stash entry is kept in case you need it again.")"
634 exit $status
635 fi
636 }
637
638 drop_stash () {
639 assert_stash_ref "$@"
640
641 git reflog delete --updateref --rewrite "${REV}" &&
642 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
643 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
644
645 # clear_stash if we just dropped the last stash entry
646 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
647 clear_stash
648 }
649
650 apply_to_branch () {
651 test -n "$1" || die "$(gettext "No branch name specified")"
652 branch=$1
653 shift 1
654
655 set -- --index "$@"
656 assert_stash_like "$@"
657
658 git checkout -b $branch $REV^ &&
659 apply_stash "$@" && {
660 test -z "$IS_STASH_REF" || drop_stash "$@"
661 }
662 }
663
664 test "$1" = "-p" && set "push" "$@"
665
666 PARSE_CACHE='--not-parsed'
667 # The default command is "push" if nothing but options are given
668 seen_non_option=
669 for opt
670 do
671 case "$opt" in
672 --) break ;;
673 -*) ;;
674 *) seen_non_option=t; break ;;
675 esac
676 done
677
678 test -n "$seen_non_option" || set "push" "$@"
679
680 # Main command set
681 case "$1" in
682 list)
683 shift
684 list_stash "$@"
685 ;;
686 show)
687 shift
688 show_stash "$@"
689 ;;
690 save)
691 shift
692 save_stash "$@"
693 ;;
694 push)
695 shift
696 push_stash "$@"
697 ;;
698 apply)
699 shift
700 apply_stash "$@"
701 ;;
702 clear)
703 shift
704 clear_stash "$@"
705 ;;
706 create)
707 shift
708 create_stash -m "$*" && echo "$w_commit"
709 ;;
710 store)
711 shift
712 store_stash "$@"
713 ;;
714 drop)
715 shift
716 drop_stash "$@"
717 ;;
718 pop)
719 shift
720 pop_stash "$@"
721 ;;
722 branch)
723 shift
724 apply_to_branch "$@"
725 ;;
726 *)
727 case $# in
728 0)
729 push_stash &&
730 say "$(gettext "(To restore them type \"git stash apply\")")"
731 ;;
732 *)
733 usage
734 esac
735 ;;
736 esac